| Wireshark 4.7.3 The Wireshark network protocol analyzer

Loading...
Searching...
No Matches
Public Attributes | List of all members
segment Struct Reference

Represents a single decoded TCP segment extracted from a captured frame for graph analysis. More...

`#include <tap-tcp-stream.h>`

## Public Attributes
struct segment * | next
uint32_t | num
nstime_t | rel_ts
uint32_t | th_seq
uint32_t | th_ack
uint32_t | th_rawseq
uint32_t | th_rawack
uint16_t | th_flags
uint32_t | th_win
uint32_t | th_seglen
uint16_t | th_sport
uint16_t | th_dport
address | ip_src
address | ip_dst
bool | ack_karn
uint8_t | num_sack_ranges
uint32_t | sack_left_edge [MAX_TCP_SACK_RANGES]
uint32_t | sack_right_edge [MAX_TCP_SACK_RANGES]

## Detailed Description

Represents a single decoded TCP segment extracted from a captured frame for graph analysis.

## Member Data Documentation

## ◆ ack_karn

bool segment::ack_karn

True if this ACK is ambiguous under Karn's algorithm (i.e. acknowledges a retransmit)

## ◆ ip_dst

address segment::ip_dst

Destination IP address

## ◆ ip_src

address segment::ip_src

Source IP address

## ◆ next

struct segment* segment::next

Pointer to the next segment in the singly-linked list

## ◆ num

uint32_t segment::num

Wireshark frame number of the packet containing this segment

## ◆ num_sack_ranges

uint8_t segment::num_sack_ranges

Number of valid SACK ranges present in this segment

## ◆ rel_ts

nstime_t segment::rel_ts

Capture timestamp relative to the first packet in the stream

## ◆ sack_left_edge

uint32_t segment::sack_left_edge[MAX_TCP_SACK_RANGES]

Left (start) sequence number of each SACK block

## ◆ sack_right_edge

uint32_t segment::sack_right_edge[MAX_TCP_SACK_RANGES]

Right (end) sequence number of each SACK block

## ◆ th_ack

uint32_t segment::th_ack

Relative TCP acknowledgement number (after base sequence subtraction)

## ◆ th_dport

uint16_t segment::th_dport

TCP destination port

## ◆ th_flags

uint16_t segment::th_flags

TCP header flags (SYN, ACK, FIN, RST, etc.)

## ◆ th_rawack

uint32_t segment::th_rawack

Raw (absolute) TCP acknowledgement number as seen in the packet

## ◆ th_rawseq

uint32_t segment::th_rawseq

Raw (absolute) TCP sequence number as seen in the packet

## ◆ th_seglen

uint32_t segment::th_seglen

Length of the TCP payload data in bytes

## ◆ th_seq

uint32_t segment::th_seq

Relative TCP sequence number (after base sequence subtraction)

## ◆ th_sport

uint16_t segment::th_sport

TCP source port

## ◆ th_win

uint32_t segment::th_win

TCP receive window size in bytes (32-bit to accommodate window scaling)

The documentation for this struct was generated from the following file:

- /builds/wireshark/wireshark/ui/tap-tcp-stream.h